Bladeren bron

[enh] New backup and restore script adapted to 2.4

zamentur 9 jaren geleden
bovenliggende
commit
420eae2bf8
2 gewijzigde bestanden met toevoegingen van 57 en 18 verwijderingen
  1. 13 8
      scripts/backup
  2. 44 10
      scripts/restore

+ 13 - 8
scripts/backup

@@ -1,15 +1,20 @@
 #!/bin/bash
-app=ynhexample
+# This backup script is adapted to Yunohost >=2.4
 
-# The parameter $1 is the backup directory location
+# The parameter $1 is the backup directory location dedicated to the app
 # which will be compressed afterward
-backup_dir=$1/apps/$app
-sudo mkdir -p $backup_dir
+backup_dir=$1
+
+# The parameter $2 is theid of the app instance ex: ynhexample__2
+app=$2
 
 # Backup sources & data
-sudo cp -a /var/www/$app/. $backup_dir/sources
+final_path=/var/www/$APP
+sudo cp -a $final_path "${backup_dir}/www" 
 
-# Copy Nginx and YunoHost parameters to make the script "standalone"
-sudo cp -a /etc/yunohost/apps/$app/. $backup_dir/yunohost
+# Copy conf file
+sudo mkdir -p "${backup_dir}/conf"
 domain=$(sudo yunohost app setting $app domain)
-sudo cp -a /etc/nginx/conf.d/$domain.d/$app.conf $backup_dir/nginx.conf
+sudo cp -a /etc/nginx/conf.d/$domain.d/$app.conf "${backup_dir}/conf/nginx.conf"
+
+# Since Yunohost 2.4 no need to backup settings in /etc/yunohost/apps/$app

+ 44 - 10
scripts/restore

@@ -1,16 +1,50 @@
 #!/bin/bash
-app=ynhexample
+# This restore script is adapted to Yunohost >=2.4
 
-# The parameter $1 is the uncompressed restore directory location
-backup_dir=$1/apps/$app
+# The parameter $1 is the backup directory location dedicated to the app
+backup_dir=$1
 
-# Restore sources & data
-sudo cp -a $backup_dir/sources/. /var/www/$app
+# The parameter $2 is the id of the app instance ex: ynhexample__2
+app=$2
 
-# Restore Nginx and YunoHost parameters
-sudo cp -a $backup_dir/yunohost/. /etc/yunohost/apps/$app
+# Get old parameter of the app
 domain=$(sudo yunohost app setting $app domain)
-sudo cp -a $backup_dir/nginx.conf /etc/nginx/conf.d/$domain.d/$app.conf
+path=$(sudo yunohost app setting $app path)
+is_public=$(sudo yunohost app setting $app is_public)
+
+# Check domain/path availability
+sudo yunohost app checkurl $domain$path -a $app
+if [[ ! $? -eq 0 ]]; then
+    echo "There is already an app on this URL : $domain$path" | sudo tee /dev/stderr
+    exit 1
+fi
+
+# Restore sources & data
+final_path=/var/www/$app
+
+if [ -d $final_path ]; then
+    echo "There is already a directory: $final_path " | sudo tee /dev/stderr
+    exit 1
+fi
+sudo cp -a "${backup_dir}/www" $final_path 
+sudo chown -R www-data: $final_path
+
+# Restore conf files
+conf=/etc/nginx/conf.d/$domain.d/$app.conf
+if [ -f $conf ]; then
+    echo "There is already a nginx conf file at this path: $conf " | sudo tee /dev/stderr
+    exit 1
+fi
+sudo cp -a "${backup_dir}/conf/nginx.conf" $conf
+
+# Reload Nginx
+sudo service nginx reload
+
+# Set ssowat config
+if [ "$is_public" = "Yes" ];
+then   
+    sudo yunohost app setting $app unprotected_uris -v "/"
+fi
+sudo yunohost app ssowatconf
+
 
-# Restart webserver
-sudo service nginx reload